%define anolis_release .0.4
%define debug_package %{nil}

Name:           smc-tools
Version:        1.8.3
Release:        1%{anolis_release}%{?dist}
Summary:        Shared Memory Communication Tools

License:        EPL
URL:            https://www.ibm.com/developerworks/linux/linux390/smc-tools.html

Requires:       man
BuildRequires:  gcc
BuildRequires:  libnl3-devel
BuildRequires:  bash-completion
BuildRequires:  clang libbpf-devel

Source0:        https://github.com/ibm-s390-linux/%{name}/archive/refs/tags/%{version}.tar.gz

Patch0:         smc-tools-1.6.0-smc_chk-py3.patch
Patch1: 	smc-tools-1.0.0-anolis-ebpf.patch
Patch2: 	1000-smc-tools-1.0.0-anolis-bpf_smc-smc-ebpf-add-operations-for-ip-strategy.patch
Patch3: 	1001-smc-tools-1.0.0-anolis-smc-ebpf-fix-issues-in-clearing-ports-and-configurin.patch
Patch4: 	1002-smc-tools-1.0.0-anolis-smc_run-bugfix-for-concurrent-socket-creation.patch
Patch5: 	1003-smc-tools-1.0.0-anolis-smcd-smcr-add-statistics-for-ringbuf-usage-of-conns-.patch
Patch6: 	1004-smc-tools-1.0.0-anolis-stats-remove-cache-file-if-it-is-corrupted.patch
Patch7: 	1005-smc-tools-1.0.0-anolis-script-add-smc_monitor_ex-tool.patch
Patch8: 	1006-smc-tools-1.0.0-anolis-smcr-smcd-introduce-tools-for-smc-traffic-capture.patch

%description
The Shared Memory Communication Tools (smc-tools) package enables usage of SMC
sockets in Linux.

%package doc
Summary: Documents for %{name}
BuildArch: noarch
Requires: %{name} = %{version}-%{release}

%description doc
Doc pages for %{name}.

%prep
%forgesetup
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

%build
%make_build CFLAGS="%{build_cflags} -I%{_includedir}/libnl3" LDFLAGS="%{build_ldflags}" V=1

%install
%make_install V=1

%files
%license LICENSE
%{_datadir}/bash-completion/
%{_mandir}/man7/af_smc.7.gz
%{_mandir}/man8/smc*
%{_bindir}/smc_pnet
%{_bindir}/smc_run
%{_bindir}/smcss
%{_bindir}/smcd
%{_bindir}/smcr
%{_bindir}/smc_dbg
%ifarch s390x
%{_bindir}/smc_rnics
%{_bindir}/smc_chk
%endif
%{_bindir}/smc_dbg
%{_libdir}/libsmc-preload.so*
%{_bindir}/smc-ebpf
%{_bindir}/anolis_smc
%{_bindir}/smc_monitor_ex
%{_bindir}/smcdump-ex

%files doc
%doc README.md

%changelog
* Mon Feb 10 2025 Wen Gu <guwen.gu@alibaba-inc.com> - 1.8.3-1.0.4
- Fix segmentation fault in concurrent socket creation
- Add statistics for ringbuf usage of conns and LGRs
- Remove stats cache file if it is corrupted
- Add smc_monitor_ex tool
- Add tools for smc traffic capture

* Wed Dec 11 2024 Wen Gu <guwen.gu@alibaba-inc.com> - 1.8.3-1.0.3
- Fix issues in clearing ports and configuring ipv4 address

* Wed Nov 27 2024 Wen Gu <guwen.gu@alibaba-inc.com> - 1.8.3-1.0.2
- Add smc ebpf operations for IPv4 strategy

* Tue Jul 09 2024 Xiaoping Liu <liuxiaoping@alibaba-inc.com> - 1.8.3-1.0.1
- Add doc sub package
- Support smc-ebpf (alibuda@linux.alibaba.com)
- fix spec on smc-ebpf, fix issues where smc-ebpf can not works (alibuda@linux.alibaba.com)


* Mon Oct 09 2023 Čestmír Kalina <ckalina@redhat.com> - 1.8.3-1
- Resolves: RHEL-11417 Upgrade smc-tools to latest version
- smc_stats: Fix man page name
- Bump version.

* Mon Dec 05 2022 Čestmír Kalina <ckalina@redhat.com> - 1.8.2-1
- Resolves: #2110414 Upgrade smc-tools to latest version

* Thu Jun 23 2022 Čestmír Kalina <ckalina@redhat.com> - 1.8.1-1
- Upgrade smc-tools to latest version
- Add User-defined EID (Enterprise ID) Support
- Resolves: #1919228
- Resolves: #2043841

* Mon Oct 18 2021 Čestmír Kalina <ckalina@redhat.com> - 1.6.1-1
- Upgrade smc-tools to latest version
- Resolves: #1984975

* Fri Jul 16 2021 Čestmír Kalina <ckalina@redhat.com> - 1.6.0-3
- Patch stats.c to fix overruns
- Patch stats.c to fix leaks
- Patch stats.c to fix fallback counter values
- Resolves: #1993469

* Fri Jul 16 2021 Čestmír Kalina <ckalina@redhat.com> - 1.6.0-2
- Patch smc_chk to use platform-python
- Resolves: #1981727

* Fri Jul 02 2021 Čestmír Kalina <ckalina@redhat.com> - 1.6.0-1
- Resolves: #1869292 Statistics Support - smc-tools part
- Resolves: #1919225 Add SMC-D Setup Check (smc-tools)
- Resolves: #1919240 Upgrade smc-tools to latest version
* Wed Feb 10 2021 Čestmír Kalina <ckalina@redhat.com> - 1.5.0-2
- Resolves: #1924787
- Add python3/man requires
* Mon Feb 08 2021 Čestmír Kalina <ckalina@redhat.com> - 1.5.0-1
- Resolves: #1924787
- Upgrade to 1.5.0
* Mon Jan 04 2021 Čestmír Kalina <ckalina@redhat.com> - 1.4.0-3
- Resolves: #1879128
- Add bash-completion to build requires

* Mon Jan 04 2021 Čestmír Kalina <ckalina@redhat.com> - 1.4.0-1
- Resolves: #1851143
- Update to 1.4.0
- Explicitly state libnl3 in include path

* Tue Jun 23 2020 Čestmír Kalina <ckalina@redhat.com> - 1.3.0-1
- Resolves: #1780304
- Update to 1.3.0

* Wed Nov 06 2019 Čestmír Kalina <ckalina@redhat.com> - 1.2.2-3
- Resolves: rhbz#1726264
- Release bump to force brew rebuild due to tagging failure.

* Wed Nov 06 2019 Čestmír Kalina <ckalina@redhat.com> - 1.2.2-2
- Resolves: rhbz#1726264
- update to 1.2.2

* Mon May 20 2019 Čestmír Kalina <ckalina@redhat.com> - 1.2.1-2
- Resolves: rhbz#1706015
- guards smc_rnics man with %ifarch s390x to avoid build failure

* Mon May 20 2019 Čestmír Kalina <ckalina@redhat.com> - 1.2.1-1
- Resolves: rhbz#1706015

* Tue Apr 02 2019 Čestmír Kalina <ckalina@redhat.com> - 1.2.0-2
- Resolves: rhbz#1683274
- guards smc_rnics with %ifarch s390x

* Tue Apr 02 2019 Čestmír Kalina <ckalina@redhat.com> - 1.2.0-1
- Resolves: rhbz#1683274
- update to 1.2.0

* Mon Jul 09 2018 Dan Horák <dan@danny.cz> - 1.1.0-1
- update to 1.1.0

* Mon Apr 16 2018 Dan Horák <dan@danny.cz> - 1.0.0-4
- fix LDFLAGS injection (#1567902)

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Jan 10 2018 Dan Horák <dan@danny.cz> - 1.0.0-2
- use make macro
- comment patches
- use distro LDFLAGS in build

* Mon Jan  8 2018 Dan Horák <dan@danny.cz> - 1.0.0-1
- initial Fedora version
